Index: /BAORadio/libindi/libindi/libs/lilxml.c
===================================================================
--- /BAORadio/libindi/libindi/libs/lilxml.c	(revision 641)
+++ /BAORadio/libindi/libindi/libs/lilxml.c	(revision 642)
@@ -682,200 +731,200 @@
  * if find final closure, return 1 and tree is in ce.
  * if need more, return 0.
- * if real trouble, return -1 and put reason in errmsg.
+ * if real trouble, return -1 and put reason in ynot.
  */
 static int
-oneXMLchar (LilXML *lp, int c, char errmsg[])
-{
-	switch (lp->cs) {
-	case LOOK4START:		/* looking for first element start */
-	    if (c == '<') {
-		pushXMLEle(lp);
-		lp->cs = LOOK4TAG;
-	    }
-	    /* silently ignore until resync */
-	    break;
-
-	case LOOK4TAG:			/* looking for element tag */
-	    if (isTokenChar (1, c)) {
-		growString (&lp->ce->tag, c);
-		lp->cs = INTAG;
-	    } else if (!isspace(c)) {
-		sprintf (errmsg, "Line %d: Bogus tag char %c", lp->ln, c);
-		return (-1);
-	    }
-	    break;
-		
-	case INTAG:			/* reading tag */
-	    if (isTokenChar (0, c))
-		growString (&lp->ce->tag, c);
-	    else if (c == '>')
-		lp->cs = LOOK4CON;
-	    else if (c == '/')
-		lp->cs = SAWSLASH;
-	    else 
-		lp->cs = LOOK4ATTRN;
-	    break;
-
-	case LOOK4ATTRN:		/* looking for attr name, > or / */
-	    if (c == '>')
-		lp->cs = LOOK4CON;
-	    else if (c == '/')
-		lp->cs = SAWSLASH;
-	    else if (isTokenChar (1, c)) {
-		XMLAtt *ap = growAtt(lp->ce);
-		growString (&ap->name, c);
-		lp->cs = INATTRN;
-	    } else if (!isspace(c)) {
-		sprintf (errmsg, "Line %d: Bogus leading attr name char: %c",
-								    lp->ln, c);
-		return (-1);
-	    }
-	    break;
-
-	case SAWSLASH:			/* saw / in element opening */
-	    if (c == '>') {
-		if (!lp->ce->pe)
-		    return(1);		/* root has no content */
-		popXMLEle(lp);
-		lp->cs = LOOK4CON;
-	    } else {
-		sprintf (errmsg, "Line %d: Bogus char %c before >", lp->ln, c);
-		return (-1);
-	    }
-	    break;
-		
-	case INATTRN:			/* reading attr name */
-	    if (isTokenChar (0, c))
-		growString (&lp->ce->at[lp->ce->nat-1]->name, c);
-	    else if (isspace(c) || c == '=')
-		lp->cs = LOOK4ATTRV;
-	    else {
-		sprintf (errmsg, "Line %d: Bogus attr name char: %c", lp->ln,c);
-		return (-1);
-	    }
-	    break;
-
-	case LOOK4ATTRV:		/* looking for attr value */
-	    if (c == '\'' || c == '"') {
-		lp->delim = c;
-		lp->cs = INATTRV;
-	    } else if (!(isspace(c) || c == '=')) {
-		sprintf (errmsg, "Line %d: No value for attribute %s", lp->ln,
-					lp->ce->at[lp->ce->nat-1]->name.s);
-		return (-1);
-	    }
-	    break;
-
-	case INATTRV:			/* in attr value */
-	    if (c == '&') {
-		newString (&lp->entity);
-		growString (&lp->entity, c);
-		lp->cs = ENTINATTRV;
-	    } else if (c == lp->delim)
-		lp->cs = LOOK4ATTRN;
-	    else if (!iscntrl(c))
-		growString (&lp->ce->at[lp->ce->nat-1]->valu, c);
-	    break;
-
-	case ENTINATTRV:		/* working on entity in attr valu */
-	    if (c == ';') {
-		/* if find a recongized esp seq, add equiv char else raw seq */
-		growString (&lp->entity, c);
-		if (decodeEntity (lp->entity.s, &c))
-		    growString (&lp->ce->at[lp->ce->nat-1]->valu, c);
-		else
-		    appendString(&lp->ce->at[lp->ce->nat-1]->valu,lp->entity.s);
-		freeString (&lp->entity);
-		lp->cs = INATTRV;
-	    } else
-		growString (&lp->entity, c);
-	    break;
-
-	case LOOK4CON:			/* skipping leading content whitespace*/
-	    if (c == '<')
-		lp->cs = SAWLTINCON;
-	    else if (!isspace(c)) {
-		growString (&lp->ce->pcdata, c);
-		lp->cs = INCON;
-	    }
-	    break;
-
-	case INCON:			/* reading content */
-	    if (c == '&') {
-		newString (&lp->entity);
-		growString (&lp->entity, c);
-		lp->cs = ENTINCON;
-	    } else if (c == '<') {
-		/* chomp trailing whitespace */
-		while (lp->ce->pcdata.sl > 0 &&
-			    isspace(lp->ce->pcdata.s[lp->ce->pcdata.sl-1]))
-		    lp->ce->pcdata.s[--(lp->ce->pcdata.sl)] = '\0';
-		lp->cs = SAWLTINCON;
-	    } else {
-		growString (&lp->ce->pcdata, c);
-	    }
-	    break;
-
-	case ENTINCON:			/* working on entity in content */
-	    if (c == ';') {
-		/* if find a recognized esc seq, add equiv char else raw seq */
-		growString (&lp->entity, c);
-		if (decodeEntity (lp->entity.s, &c))
-		    growString (&lp->ce->pcdata, c);
-		else {
-		    appendString(&lp->ce->pcdata, lp->entity.s);
-		    lp->ce->pcdata_hasent = 1;
-		}
-		freeString (&lp->entity);
-		lp->cs = INCON;
-	    } else
-		growString (&lp->entity, c);
-	    break;
-
-	case SAWLTINCON:		/* saw < in content */
-	    if (c == '/') {
-		resetEndTag(lp);
-		lp->cs = LOOK4CLOSETAG;
-	    } else {
-		pushXMLEle(lp);
-		if (isTokenChar(1,c)) {
-		    growString (&lp->ce->tag, c);
-		    lp->cs = INTAG;
-		} else
-		    lp->cs = LOOK4TAG;
-	    }
-	    break;
-
-	case LOOK4CLOSETAG:		/* looking for closing tag after < */
-	    if (isTokenChar (1, c)) {
-		growString (&lp->endtag, c);
-		lp->cs = INCLOSETAG;
-	    } else if (!isspace(c)) {
-		sprintf (errmsg, "Line %d: Bogus preend tag char %c", lp->ln,c);
-		return (-1);
-	    }
-	    break;
-
-	case INCLOSETAG:		/* reading closing tag */
-	    if (isTokenChar(0, c))
-		growString (&lp->endtag, c);
-	    else if (c == '>') {
-		if (strcmp (lp->ce->tag.s, lp->endtag.s)) {
-		    sprintf (errmsg,"Line %d: closing tag %s does not match %s",
-				    lp->ln, lp->endtag.s, lp->ce->tag.s);
-		    return (-1);
-		} else if (lp->ce->pe) {
-		    popXMLEle(lp);
-		    lp->cs = LOOK4CON;	/* back to content after nested elem */
-		} else
-		    return (1);		/* yes! */
-	    } else if (!isspace(c)) {
-		sprintf (errmsg, "Line %d: Bogus end tag char %c", lp->ln, c);
-		return (-1);
-	    }
-	    break;
-	}
-
-	return (0);
+oneXMLchar (LilXML *lp, int c, char ynot[])
+{
+        switch (lp->cs) {
+        case LOOK4START:		/* looking for first element start */
+            if (c == '<') {
+                pushXMLEle(lp);
+                lp->cs = LOOK4TAG;
+            }
+            /* silently ignore until resync */
+            break;
+
+        case LOOK4TAG:			/* looking for element tag */
+            if (isTokenChar (1, c)) {
+                growString (&lp->ce->tag, c);
+                lp->cs = INTAG;
+            } else if (!isspace(c)) {
+                sprintf (ynot, "Line %d: Bogus tag char %c", lp->ln, c);
+                return (-1);
+            }
+            break;
+
+        case INTAG:			/* reading tag */
+            if (isTokenChar (0, c))
+                growString (&lp->ce->tag, c);
+            else if (c == '>')
+                lp->cs = LOOK4CON;
+            else if (c == '/')
+                lp->cs = SAWSLASH;
+            else
+                lp->cs = LOOK4ATTRN;
+            break;
+
+        case LOOK4ATTRN:		/* looking for attr name, > or / */
+            if (c == '>')
+                lp->cs = LOOK4CON;
+            else if (c == '/')
+                lp->cs = SAWSLASH;
+            else if (isTokenChar (1, c)) {
+                XMLAtt *ap = growAtt(lp->ce);
+                growString (&ap->name, c);
+                lp->cs = INATTRN;
+            } else if (!isspace(c)) {
+                sprintf (ynot, "Line %d: Bogus leading attr name char: %c",
+                                                                    lp->ln, c);
+                return (-1);
+            }
+            break;
+
+        case SAWSLASH:			/* saw / in element opening */
+            if (c == '>') {
+                if (!lp->ce->pe)
+                    return(1);		/* root has no content */
+                popXMLEle(lp);
+                lp->cs = LOOK4CON;
+            } else {
+                sprintf (ynot, "Line %d: Bogus char %c before >", lp->ln, c);
+                return (-1);
+            }
+            break;
+
+        case INATTRN:			/* reading attr name */
+            if (isTokenChar (0, c))
+                growString (&lp->ce->at[lp->ce->nat-1]->name, c);
+            else if (isspace(c) || c == '=')
+                lp->cs = LOOK4ATTRV;
+            else {
+                sprintf (ynot, "Line %d: Bogus attr name char: %c", lp->ln,c);
+                return (-1);
+            }
+            break;
+
+        case LOOK4ATTRV:		/* looking for attr value */
+            if (c == '\'' || c == '"') {
+                lp->delim = c;
+                lp->cs = INATTRV;
+            } else if (!(isspace(c) || c == '=')) {
+                sprintf (ynot, "Line %d: No value for attribute %s", lp->ln,
+                                        lp->ce->at[lp->ce->nat-1]->name.s);
+                return (-1);
+            }
+            break;
+
+        case INATTRV:			/* in attr value */
+            if (c == '&') {
+                newString (&lp->entity);
+                growString (&lp->entity, c);
+                lp->cs = ENTINATTRV;
+            } else if (c == lp->delim)
+                lp->cs = LOOK4ATTRN;
+            else if (!iscntrl(c))
+                growString (&lp->ce->at[lp->ce->nat-1]->valu, c);
+            break;
+
+        case ENTINATTRV:		/* working on entity in attr valu */
+            if (c == ';') {
+                /* if find a recongized esp seq, add equiv char else raw seq */
+                growString (&lp->entity, c);
+                if (decodeEntity (lp->entity.s, &c))
+                    growString (&lp->ce->at[lp->ce->nat-1]->valu, c);
+                else
+                    appendString(&lp->ce->at[lp->ce->nat-1]->valu,lp->entity.s);
+                freeString (&lp->entity);
+                lp->cs = INATTRV;
+            } else
+                growString (&lp->entity, c);
+            break;
+
+        case LOOK4CON:			/* skipping leading content whitespace*/
+            if (c == '<')
+                lp->cs = SAWLTINCON;
+            else if (!isspace(c)) {
+                growString (&lp->ce->pcdata, c);
+                lp->cs = INCON;
+            }
+            break;
+
+        case INCON:			/* reading content */
+            if (c == '&') {
+                newString (&lp->entity);
+                growString (&lp->entity, c);
+                lp->cs = ENTINCON;
+            } else if (c == '<') {
+                /* chomp trailing whitespace */
+                while (lp->ce->pcdata.sl > 0 &&
+                            isspace(lp->ce->pcdata.s[lp->ce->pcdata.sl-1]))
+                    lp->ce->pcdata.s[--(lp->ce->pcdata.sl)] = '\0';
+                lp->cs = SAWLTINCON;
+            } else {
+                growString (&lp->ce->pcdata, c);
+            }
+            break;
+
+        case ENTINCON:			/* working on entity in content */
+            if (c == ';') {
+                /* if find a recognized esc seq, add equiv char else raw seq */
+                growString (&lp->entity, c);
+                if (decodeEntity (lp->entity.s, &c))
+                    growString (&lp->ce->pcdata, c);
+                else {
+                    appendString(&lp->ce->pcdata, lp->entity.s);
+                    lp->ce->pcdata_hasent = 1;
+                }
+                freeString (&lp->entity);
+                lp->cs = INCON;
+            } else
+                growString (&lp->entity, c);
+            break;
+
+        case SAWLTINCON:		/* saw < in content */
+            if (c == '/') {
+                resetEndTag(lp);
+                lp->cs = LOOK4CLOSETAG;
+            } else {
+                pushXMLEle(lp);
+                if (isTokenChar(1,c)) {
+                    growString (&lp->ce->tag, c);
+                    lp->cs = INTAG;
+                } else
+                    lp->cs = LOOK4TAG;
+            }
+            break;
+
+        case LOOK4CLOSETAG:		/* looking for closing tag after < */
+            if (isTokenChar (1, c)) {
+                growString (&lp->endtag, c);
+                lp->cs = INCLOSETAG;
+            } else if (!isspace(c)) {
+                sprintf (ynot, "Line %d: Bogus preend tag char %c", lp->ln,c);
+                return (-1);
+            }
+            break;
+
+        case INCLOSETAG:		/* reading closing tag */
+            if (isTokenChar(0, c))
+                growString (&lp->endtag, c);
+            else if (c == '>') {
+                if (strcmp (lp->ce->tag.s, lp->endtag.s)) {
+                    sprintf (ynot,"Line %d: closing tag %s does not match %s",
+                                    lp->ln, lp->endtag.s, lp->ce->tag.s);
+                    return (-1);
+                } else if (lp->ce->pe) {
+                    popXMLEle(lp);
+                    lp->cs = LOOK4CON;	/* back to content after nested elem */
+                } else
+                    return (1);		/* yes! */
+            } else if (!isspace(c)) {
+                sprintf (ynot, "Line %d: Bogus end tag char %c", lp->ln, c);
+                return (-1);
+            }
+            break;
+        }
+
+        return (0);
 }
 
@@ -884,10 +933,10 @@
 initParser(LilXML *lp)
 {
-	delXMLEle (lp->ce);
-	freeString (&lp->endtag);
-	memset (lp, 0, sizeof(*lp));
-	newString (&lp->endtag);
-	lp->cs = LOOK4START;
-	lp->ln = 1;
+        delXMLEle (lp->ce);
+        freeString (&lp->endtag);
+        memset (lp, 0, sizeof(*lp));
+        newString (&lp->endtag);
+        lp->cs = LOOK4START;
+        lp->ln = 1;
 }
 
@@ -900,6 +949,6 @@
 pushXMLEle(LilXML *lp)
 {
-	lp->ce = growEle (lp->ce);
-	resetEndTag(lp);
+        lp->ce = growEle (lp->ce);
+        resetEndTag(lp);
 }
 
@@ -910,6 +959,6 @@
 popXMLEle(LilXML *lp)
 {
-	lp->ce = lp->ce->pe;
-	resetEndTag(lp);
+        lp->ce = lp->ce->pe;
+        resetEndTag(lp);
 }
 
@@ -918,17 +967,17 @@
 growEle (XMLEle *pe)
 {
-	XMLEle *newe = (XMLEle *) moremem (NULL, sizeof(XMLEle));
-
-	memset (newe, 0, sizeof(XMLEle));
-	newString (&newe->tag);
-	newString (&newe->pcdata);
-	newe->pe = pe;
-
-	if (pe) {
-	    pe->el = (XMLEle **) moremem (pe->el, (pe->nel+1)*sizeof(XMLEle *));
-	    pe->el[pe->nel++] = newe;
-	}
-
-	return (newe);
+        XMLEle *newe = (XMLEle *) moremem (NULL, sizeof(XMLEle));
+
+        memset (newe, 0, sizeof(XMLEle));
+        newString (&newe->tag);
+        newString (&newe->pcdata);
+        newe->pe = pe;
+
+        if (pe) {
+            pe->el = (XMLEle **) moremem (pe->el, (pe->nel+1)*sizeof(XMLEle *));
+            pe->el[pe->nel++] = newe;
+        }
+
+        return (newe);
 }
 
@@ -937,15 +986,15 @@
 growAtt(XMLEle *ep)
 {
-	XMLAtt *newa = (XMLAtt *) moremem (NULL, sizeof(XMLAtt));
-
-	memset (newa, 0, sizeof(*newa));
-	newString(&newa->name);
-	newString(&newa->valu);
-	newa->ce = ep;
-
-	ep->at = (XMLAtt **) moremem (ep->at, (ep->nat+1)*sizeof(XMLAtt *));
-	ep->at[ep->nat++] = newa;
-
-	return (newa);
+        XMLAtt *newa = (XMLAtt *) moremem (NULL, sizeof(XMLAtt));
+
+        memset (newa, 0, sizeof(*newa));
+        newString(&newa->name);
+        newString(&newa->valu);
+        newa->ce = ep;
+
+        ep->at = (XMLAtt **) moremem (ep->at, (ep->nat+1)*sizeof(XMLAtt *));
+        ep->at[ep->nat++] = newa;
+
+        return (newa);
 }
 
@@ -954,9 +1003,9 @@
 freeAtt (XMLAtt *a)
 {
-	if (!a)
-	    return;
-	freeString (&a->name);
-	freeString (&a->valu);
-	(*myfree)(a);
+        if (!a)
+            return;
+        freeString (&a->name);
+        freeString (&a->valu);
+        (*myfree)(a);
 }
 
@@ -965,6 +1014,6 @@
 resetEndTag(LilXML *lp)
 {
-	freeString (&lp->endtag);
-	newString (&lp->endtag);
+        freeString (&lp->endtag);
+        newString (&lp->endtag);
 }
 
@@ -975,5 +1024,5 @@
 isTokenChar (int start, int c)
 {
-	return (isalpha(c) || c == '_' || (!start && isdigit(c)));
+        return (isalpha(c) || c == '_' || (!start && isdigit(c)));
 }
 
@@ -982,15 +1031,15 @@
 growString (String *sp, int c)
 {
-	int l = sp->sl + 2;		/* need room for '\0' plus c */
-
-	if (l > sp->sm) {
-	    if (!sp->s)
-		newString (sp);
-	    else
-		sp->s = (char *) moremem (sp->s, sp->sm *= 2);
-	}
-	sp->s[--l] = '\0';
-	sp->s[--l] = (char)c;
-	sp->sl++;
+        int l = sp->sl + 2;		/* need room for '\0' plus c */
+
+        if (l > sp->sm) {
+            if (!sp->s)
+                newString (sp);
+            else
+                sp->s = (char *) moremem (sp->s, sp->sm *= 2);
+        }
+        sp->s[--l] = '\0';
+        sp->s[--l] = (char)c;
+        sp->sl++;
 }
 
@@ -999,15 +1048,15 @@
 appendString (String *sp, const char *str)
 {
-	int strl = strlen (str);
-	int l = sp->sl + strl + 1;	/* need room for '\0' */
-
-	if (l > sp->sm) {
-	    if (!sp->s)
-		newString (sp);
-	    if (l > sp->sm)
-		sp->s = (char *) moremem (sp->s, (sp->sm = l));
-	}
-	strcpy (&sp->s[sp->sl], str);
-	sp->sl += strl;		
+        int strl = strlen (str);
+        int l = sp->sl + strl + 1;	/* need room for '\0' */
+
+        if (l > sp->sm) {
+            if (!sp->s)
+                newString (sp);
+            if (l > sp->sm)
+                sp->s = (char *) moremem (sp->s, (sp->sm = l));
+        }
+        strcpy (&sp->s[sp->sl], str);
+        sp->sl += strl;
 }
 
@@ -1016,8 +1065,8 @@
 newString(String *sp)
 {
-	sp->s = (char *)moremem(NULL, MINMEM);
-	sp->sm = MINMEM;
-	*sp->s = '\0';
-	sp->sl = 0;
+        sp->s = (char *)moremem(NULL, MINMEM);
+        sp->sm = MINMEM;
+        *sp->s = '\0';
+        sp->sl = 0;
 }
 
@@ -1026,9 +1075,9 @@
 freeString (String *sp)
 {
-	if (sp->s)
-	    (*myfree) (sp->s);
-	sp->s = NULL;
-	sp->sl = 0;
-	sp->sm = 0;
+        if (sp->s)
+            (*myfree) (sp->s);
+        sp->s = NULL;
+        sp->sl = 0;
+        sp->sm = 0;
 }
 
@@ -1037,5 +1086,5 @@
 moremem (void *old, int n)
 {
-	return (old ? (*myrealloc)(old, n) : (*mymalloc)(n));
+        return (old ? (*myrealloc)(old, n) : (*mymalloc)(n));
 }
 
@@ -1044,37 +1093,36 @@
 main (int ac, char *av[])
 {
-	LilXML *lp = newLilXML();
-	char errmsg[1024];
-	XMLEle *root;
-
-	root = readXMLFile (stdin, lp, errmsg);
-	if (root) {
-	    char *str;
-	    int l;
-
-	    if (ac > 1) {
-		XMLEle *theend = addXMLEle (root, "theend");
-		editXMLEle (theend, "Added to test editing");
-		addXMLAtt (theend, "hello", "world");
-	    }
-
-	    fprintf (stderr, "::::::::::::: %s\n", tagXMLEle(root));
-	    prXMLEle (stdout, root, 0);
-
-	    l = sprlXMLEle (root, 0);
-	    str = malloc (l+1);
-	    fprintf (stderr, "::::::::::::: %s : %d : %d",
-				tagXMLEle(root), l, sprXMLEle (str, root, 0));
-	    fprintf (stderr, ": %d\n", printf ("%s", str));
-
-	    delXMLEle (root);
-	} else if (errmsg[0]) {
-	    fprintf (stderr, "Error: %s\n", errmsg);
-	}
-
-	delLilXML (lp);
-
-	return (0);
+        LilXML *lp = newLilXML();
+        char ynot[1024];
+        XMLEle *root;
+
+        root = readXMLFile (stdin, lp, ynot);
+        if (root) {
+            char *str;
+            int l;
+
+            if (ac > 1) {
+                XMLEle *theend = addXMLEle (root, "theend");
+                editXMLEle (theend, "Added to test editing");
+                addXMLAtt (theend, "hello", "world");
+            }
+
+            fprintf (stderr, "::::::::::::: %s\n", tagXMLEle(root));
+            prXMLEle (stdout, root, 0);
+
+            l = sprlXMLEle (root, 0);
+            str = malloc (l+1);
+            fprintf (stderr, "::::::::::::: %s : %d : %d",
+                                tagXMLEle(root), l, sprXMLEle (str, root, 0));
+            fprintf (stderr, ": %d\n", printf ("%s", str));
+
+            delXMLEle (root);
+        } else if (ynot[0]) {
+            fprintf (stderr, "Error: %s\n", ynot);
+        }
+
+        delLilXML (lp);
+
+        return (0);
 }
 #endif
-
Index: /BAORadio/libindi/libindi/libs/webcam/port.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/webcam/port.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/libs/webcam/port.cpp	(revision 642)
@@ -38,11 +38,18 @@
 #include <sys/stat.h>
 #endif /* LOCKING */
-
 #ifdef __linux__
-  #if defined(arm) || defined(__hppa__) || defined(__sparc__) || defined(__ppc__) || defined(__powerpc__) || defined(__s390__) || defined(__s390x__) || defined(__mips__) || defined(__mc68000__)
+#if defined(arm) || defined(__hppa__) || defined(__sparc__) || defined(__ppc__) \
+	|| defined(__powerpc__) || defined(__s390__) || defined(__s390x__)\
+	|| defined(__mips__) || defined(__mc68000__) || defined(__sh__)
+#define NO_SYSIO
+#endif /* architechtures */
+#endif /* __linux__ */
+
+#ifdef __linux__
+  #if defined(NO_SYSIO)
   #include <fcntl.h>
   #else
   #include <sys/io.h>
-  #endif /* arm */
+  #endif /* NO_SYSIO */
 #elif defined(QNX)
 #include <conio.h>
@@ -77,5 +84,5 @@
 
 #ifdef LINUX
-#if defined(arm) || defined(__hppa__) || defined(__sparc__) || defined(__ppc__) || defined(__powerpc__) || defined(__s390__) || defined(__s390x__) || defined(__mips__) || defined(__mc68000__)
+#ifdef NO_SYSIO
   if ((devport = open("/dev/port", O_RDWR)) < 0) {
     perror("open /dev/port");
@@ -87,5 +94,5 @@
     return;
   }
-#endif /* arm */
+#endif /* NO_SYSIO */
 #elif defined(FREEBSD)
   if ((devio = fopen("/dev/io", "r+")) == NULL) {
@@ -121,5 +128,5 @@
 #endif /* LOCKING */
 #ifdef LINUX
-#if defined(arm) || defined(__hppa__) || defined(__sparc__) || defined(__ppc__) || defined(__powerpc__) || defined(__s390__) || defined(__s390x__) || defined(__mips__) || defined(__mc68000__)
+#ifdef NO_SYSIO
   if (devport >= 0)
     close(devport);
@@ -129,5 +136,5 @@
                                   // be root
       perror("ioperm()");
-#endif /* arm */
+#endif /* NO_SYSIO */
 #elif defined(FREEBSD)
   if (devio != NULL)
Index: /BAORadio/libindi/libindi/tools/compiler.c
===================================================================
--- /BAORadio/libindi/libindi/tools/compiler.c	(revision 641)
+++ /BAORadio/libindi/libindi/tools/compiler.c	(revision 642)
@@ -267,7 +267,7 @@
 next_token ()
 {
-	static char toomv[] = "More than %d variables";
-	static char toomc[] = "More than %d constants";
-	static char badop[] = "Illegal operator";
+	static const char toomv[] = "More than %d variables";
+	static const char toomc[] = "More than %d constants";
+	static const char badop[] = "Illegal operator";
 	int tok = ERR;	/* just something illegal */
 	char c;
@@ -295,13 +295,13 @@
 	case '|':
 	    if (*cexpr == '|') { cexpr++; tok = OR; }
-	    else { (void) sprintf (err_msg, badop); return (ERR); }
+            else { (void) strcpy (err_msg, badop); return (ERR); }
 	    break;
 	case '&':
 	    if (*cexpr == '&') { cexpr++; tok = AND; }
-	    else { (void) sprintf (err_msg, badop); return (ERR); }
+            else { (void) strcpy (err_msg, badop); return (ERR); }
 	    break;
 	case '=':
 	    if (*cexpr == '=') { cexpr++; tok = EQ; }
-	    else { (void) sprintf (err_msg, badop); return (ERR); }
+            else { (void) strcpy (err_msg, badop); return (ERR); }
 	    break;
 	case '!':
Index: /BAORadio/libindi/libindi/tools/evalINDI.c
===================================================================
--- /BAORadio/libindi/libindi/tools/evalINDI.c	(revision 641)
+++ /BAORadio/libindi/libindi/tools/evalINDI.c	(revision 642)
@@ -347,6 +347,6 @@
 {
 	char *t = tagXMLEle (root);
-	char *d = findXMLAttValu (root, "device");
-	char *n = findXMLAttValu (root, "name");
+        const char *d = findXMLAttValu (root, "device");
+        const char *n = findXMLAttValu (root, "name");
 	int nset = 0;
 	double v;
@@ -397,5 +397,5 @@
 
 	/* check special elements */
-	t = findXMLAttValu (root, "state");
+        t = (char *) findXMLAttValu (root, "state");
 	if (t[0]) {
 	    sprintf (prop, "%s.%s._STATE", d, n);
@@ -407,5 +407,5 @@
 	    }
 	}
-	t = findXMLAttValu (root, "timestamp");
+        t = (char *) findXMLAttValu (root, "timestamp");
 	if (t[0]) {
 	    sprintf (prop, "%s.%s._TS", d, n);
Index: /BAORadio/libindi/libindi/tools/getINDIproperty.c
===================================================================
--- /BAORadio/libindi/libindi/tools/getINDIproperty.c	(revision 641)
+++ /BAORadio/libindi/libindi/tools/getINDIproperty.c	(revision 642)
@@ -446,13 +446,13 @@
 		if (strcmp (tagXMLEle (root), defs[j].vec) == 0) {
 		    /* legal defXXXVector, check device */
-		    char *dev = findXMLAttValu (root, "device");
+                    char *dev = (char *) findXMLAttValu (root, "device");
 		    char *idev = srchs[i].d;
 		    if (idev[0] == WILDCARD || !strcmp (dev,idev)) {
 			/* found device, check name */
-			char *nam = findXMLAttValu (root, "name");
+                        char *nam = (char *) findXMLAttValu (root, "name");
 			char *iprop = srchs[i].p;
 			if (iprop[0] == WILDCARD || !strcmp (nam,iprop)) {
 			    /* found device and name, check perm */
-			    char *perm = findXMLAttValu (root, "perm");
+                            char *perm = (char *) findXMLAttValu (root, "perm");
 			    if (!wflag && perm[0] && !strchr (perm, 'r')) {
 				if (verbose)
@@ -491,5 +491,5 @@
 	    if (strcmp (iele, kwattr[i].keyword) == 0) {
 		/* just print the property state, not the element values */
-		char *s = findXMLAttValu (root, kwattr[i].indiattr);
+                char *s = (char *) findXMLAttValu (root, kwattr[i].indiattr);
 		sp->ok = 1;   			/* progress */
 		if (onematch && justvalue)
@@ -505,5 +505,5 @@
 	    if (!strcmp (tagXMLEle (ep), defone)) {
 		/* legal defXXX, check deeper */
-		char *enam = findXMLAttValu (ep, "name");
+                char *enam = (char *) findXMLAttValu (ep, "name");
 		if (iele[0]==WILDCARD || !strcmp(enam,iele)) {
 		    /* found it! */
@@ -556,5 +556,5 @@
 
 	/* get format and length */
-	format = findXMLAttValu (root, "format");
+        format = (char *) findXMLAttValu (root, "format");
 	isz = !strcmp (&format[strlen(format)-2], ".z");
 
Index: /BAORadio/libindi/libindi/tools/setINDIproperty.c
===================================================================
--- /BAORadio/libindi/libindi/tools/setINDIproperty.c	(revision 641)
+++ /BAORadio/libindi/libindi/tools/setINDIproperty.c	(revision 642)
@@ -419,6 +419,6 @@
 
 	/* check each set for matching device and property name, send if ok */
-	rdev  = findXMLAttValu (root, "device");
-	rprop = findXMLAttValu (root, "name");
+        rdev  = (char *) findXMLAttValu (root, "device");
+        rprop = (char *) findXMLAttValu (root, "name");
 	if (verbose > 1)
 	    fprintf (stderr, "Read definition for %s.%s\n", rdev, rprop);
